%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Sanjib Sur (sur2 at wisc.edu), Xinyu Zhang (xyzhang at ece.wisc.edu)
% This project is Licensed under the the GNU General Public License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [delTheta] = fm_demod(quad_samples, gain)
    
    for qs = 2:length(quad_samples)
        complex_product = quad_samples(qs) * conj(quad_samples(qs-1));
        if real(complex_product) == 0
            delTheta(qs-1) = 0;
        else
            delTheta(qs-1) = gain * atan(imag(complex_product)/...
                                         real(complex_product));
        end
    end

    delTheta = delTheta.';
end