%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Sanjib Sur (sur2 at wisc.edu), Xinyu Zhang (xyzhang at ece.wisc.edu)
% This project is Licensed under the the GNU General Public License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [raw_samples] = remove_dco(alpha, raw_samples_wDCO)

assert(alpha < 1);

% Estimate DC offset per sample, based on previous samples
freq_offset = single_pole_iir_filter(alpha, raw_samples_wDCO);
% Remove DC offset from the samples
raw_samples = raw_samples_wDCO - freq_offset;

end